Summary: LAM (Local Area Multicomputer) programming environment
Name: lam
Version: 6.3.1
Release: 4
Copyright: GPL
Group: Development/Libraries
Source: http://www.mpi.nd.edu/downloads/lam/lam-%{version}.tar.gz
Patch0: lam-6.3.1-buildroot.patch
URL: http://www.mpi.nd.edu/lam/
BuildRoot: /var/tmp/%{name}-root
BuildPrereq: egcs-g77

%description 
LAM (Local Area Multicomputer) is an MPI programming environment and
development system for heterogeneous computers on a network. With
LAM/MPI, a dedicated cluster or an existing network computing
infrastructure can act as one parallel computer solving one problem.
LAM/MPI is considered to be "cluster friendly", in that it offers
daemon-based process startup/control as well as fast client-to-client
message passing protocols.  LAM/MPI can use TCP/IP and/or shared
memory for message passing (different RPMs are supplied for this --
see the main LAM web site for details).

LAM features a full implementation of Message-Passing Interface
version 1 (with the exception that LAM does not support cancelling of
sends), and much of version 2.  Compliant applications are source code
portable between LAM and any other implementation of MPI. In addition
to meeting the standard in a high quality manner, LAM/MPI offers
extensive monitoring capabilities to support debugging. Monitoring
happens on two levels.  LAM/MPI has the hooks to allow a snapshot of
process and message status to be taken at any time during an
application run.  The status includes all aspects of synchronization
plus datatype map / signature, communicator group membership and
message contents (see the XMPI application on the main LAM web site).
On the second level, the MPI library is instrumented to produce a
cummulative record of communication, which can be visualized either at
runtime or post-mortem.

%prep
%setup -q
%patch0 -p1 -b .br

# put the $(RPM_BUILD_ROOT) in front of the LAMHOME for dependencies
find . -type f -a -name Depends -exec \
	perl -p -i -e 's/\$\(LAMHOME\)/\$\(RPM_BUILD_ROOT\)\$\(LAMHOME\)/g;' {} \;

## lam includes are really in /usr/include/lam, not /usr/include
find . -type f -a \( -name Depends -o -name Makefile \) -exec \
	perl -p -i -e 's|(\$\(LAMHOME\)/include)/([^/]*\.h)$|$1/lam/$2|g;' {} \;

%clean
rm -rf $RPM_BUILD_ROOT

%build
./configure --with-rpi=tcp --with-romio --prefix=/usr

%install
rm -rf $RPM_BUILD_ROOT
# Well, damn, make is also "make install". So much for configurability
# or "repeat your build unitl succeeds without copying a ton of crap over in
# some other dir every time you do a 'make'". Maybe I'm old fashion...
make

# ROMIO
make romio
# now the /usr/lib/romio/Makefile is all busted...
perl -p -i -e "s|$RPM_BUILD_ROOT||g;" $RPM_BUILD_ROOT/usr/lib/romio/Makefile

# MPI2C++
make mpi2c++
# need to fix balky
perl -p -i -e "s|$RPM_BUILD_ROOT||g;" $RPM_BUILD_ROOT/usr/bin/balky

%files
%defattr(-,root,root)
%doc examples
/usr/bin/*
/usr/man/man?/*
/usr/man/share/mpi*
/usr/include/lam
/usr/include/mpi2c++-1.0.5
/usr/include/mpi2c++
/usr/lib/lam
/usr/lib/romio
/usr/lib/libmpi++.a
/usr/boot/*
/usr/share/lam
%doc COPYRIGHT INSTALL README RELEASE_NOTES 
%doc romio/doc/*

%changelog
* Sat Mar 04 2000 Cristian Gafton <gafton@redhat.com>
- fixed the whole tree the hard way - get into each Makefile and fix
  brokeness on a case by case basis. Traces of Buildroot should be 
  erradicated by now.

* Thu Mar 02 2000 Cristian Gafton <gafton@redhat.com>
- put back the mpi2c++ stuff. 

* Tue Feb 29 2000 Cristian Gafton <gafton@redhat.com>
- take out the mpi2c++ in a separate package

* Fri Feb 04 2000 Cristian Gafton <gafton@redhat.com>
- first version of the package
